import { CameraInterface } from '../plugins/camera/index';
import { Contacts } from '../plugins/contacts/index';
import { Accelerometer } from '../plugins/device-motion/index';
import { Compass } from '../plugins/device-orientation/index';
import { Device } from '../plugins/device/index';
import { Notification } from '../plugins/dialogs/index';
import { FileTransferInterface } from '../plugins/file-transfer/index';
import { FileError, FileSystem } from '../plugins/file/index';
import { LocalFileSystem } from '../plugins/file/local-file-system';
import { MediaInterface } from '../plugins/media/index';
import { ConnectionInterface } from '../plugins/network-information/index';
import { PersistentStorage } from '../plugins/storage/index';
export declare class AWProxy {
    static exec(successHandler: any, errorHandler: any, name: string, method: string, args: any[]): void;
    static accelerometer(): Accelerometer;
    static camera(): CameraInterface;
    static Camera(): any;
    static compass(): Compass;
    static connection(): ConnectionInterface;
    static Connection(): any;
    static contacts(): Contacts;
    static device(): Device;
    static document(): any;
    static file(): any;
    static filetransfer(): FileTransferInterface;
    static fileTransfer(): FileTransferInterface;
    static doGetFileTransfer(): FileTransferInterface;
    static geolocation(): Geolocation;
    static localFileSystem(): any;
    static media(src: any, successHandler: any, errorHandler: any, statusChangeHandler: any): MediaInterface;
    static notification(): Notification;
    static requestFileSystem(type: LocalFileSystem, size: number, successCallback: (fileSystem: FileSystem) => void, errorCallback?: (fileError: FileError) => void): void;
    static vibrate(time: number): void;
    static webview(): any;
    static storage(): Storage;
    static persistentStorage(): PersistentStorage;
    static isDesktopEnv(): boolean;
    static isMobileEnv(): boolean;
    static getDesktopPlugin(pluginName: string): any;
    private static execMobile(successHandler, errorHandler, name, method, args);
    private static execDesktop(successHandler, errorHandler, name, method, args);
}
